Lets say you want to do some math like 3/5 or 1/2, etc (any float point math).

You can do something like this

echo 3 5 | awk '{print $1/$2}'

The problem with that is that we are forking and also opening up a whole new program, this is going to be slow with many calculations. This awesome script (written by dteske) solves this issue all together.

So if you want floating point precision in a shell, usually you would have to use something like awk or other tools. With this awesome tool you dont need anything weird, all tools are provided by the shell. I tested with Bash version 4 and it worked.

Sources: https://raw.githubusercontent.com/FrauBSD/FrauBSD/master/usr.sbin/bsdconfig/share/float.subr  Float.subr needs this shell script: http://svnweb.freebsd.org/base/head/usr.sbin/bsdconfig/share/common.subr?view=co

Installation of float.subr

Download the files: fetch (For FreeBSD)

fetch -qo float.subr https://raw.githubusercontent.com/FrauBSD/FrauBSD/master/usr.sbin/bsdconfig/share/float.subr
fetch -qo common.subr 'http://svnweb.freebsd.org/base/head/usr.sbin/bsdconfig/share/common.subr?view=co'

Wget:
wget float.subr https://raw.githubusercontent.com/FrauBSD/FrauBSD/master/usr.sbin/bsdconfig/share/float.subr -O float.subr
wget common.subr 'http://svnweb.freebsd.org/base/head/usr.sbin/bsdconfig/share/common.subr?view=co' -O common.subr

Edit float.subr to load common.subr correctly

Change this:

. $BSDCFG_SHARE/common.subr || exit 1

To this (since common.subr will be in the same dir as float.subr, you can just change it to this – just delete the $BSDCFG_SHARE/  characters):
. common.subr || exit 1

Try these commands (note I open up a subshell so that float.subrs functions & variables sets dont mess with the local shell):

Example 1: 1/2 which is 0.5

(. float.subr; f_float 1 / 2; )

Output should be 0.50

That used subshells, so that the functions which were given by float.subr wouldnt leak to the main shell (they will only be used in the main shell). You can also do this

# source float.subr so that all of its functions are available to us
. float.subr;
# one of those functions is the f_float funciton
f_float 1 / 2;

Or do this (instead of sourcing the script with a dot . <scriptpath>  source it with a source <scriptpath> – there is no difference):
# instead of running/sourcing the script with . you can run it with float.subr
source float.subr;
f_float 1 / 2;

Note that we don’t want to run the script with the regular dot slash notation ./float.subr . This is because running a script with dot slash notation, might run the script in a new subshell of its own, as a child process, and then you wont have access to its functions like f_float. However when you source a script with “source” or dot “.”, the script is ran in the current shell (not as a child process), and then you have access to the functions.

My favorite way to run these (and in the end it really depends on what I want to achived), would be to source the script and run its function/functions in a subshell of its own, like this (. float.subr; f_float 1 / 2; ) . That way everything in the parenthesis has access to the float.subr functions, but also they dont leak and get left behind in my shell. Its all completely trivial, because if my shell gets “dirty” with functions that I dont like, I can just close out my shell, and log back in and then I will have a clean shell again.

Example 2:

Divide 1 by 17. 1/17. More precision (6 decimal places)

(. float.subr; f_float -n 6 1 / 17;)

Output should be 0.058823

Thanks dteske!

SIDENOTE: you can move both float.subr and common.subr to a path in your PATH env so that you always have quick access to it

Copy of both scripts (as of March 28th 2016)

float.subr:

if [ ! "$_FLOAT_SUBR" ]; then _FLOAT_SUBR=1
#
# Copyright (c) 2014-2016 Devin Teske
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $FrauBSD: usr.sbin/bsdconfig/share/float.subr 2016-01-18 13:28:42 -0800 freebsdfrau $
# $FreeBSD$
#
############################################################ INCLUDES

BSDCFG_SHARE="/usr/share/bsdconfig"
. $BSDCFG_SHARE/common.subr || exit 1

############################################################ GLOBALS

#
# Decimal point (locale specific)
#
FLOAT_DECIMAL_POINT=$(
        export LC_ALL LC_NUMERIC
        locale -k decimal_point 2> /dev/null
)
case "$FLOAT_DECIMAL_POINT" in
*=\"?\")
        FLOAT_DECIMAL_POINT="${FLOAT_DECIMAL_POINT##*=?}"
        FLOAT_DECIMAL_POINT="${FLOAT_DECIMAL_POINT%?}" ;;
*)
        FLOAT_DECIMAL_POINT=
esac
: ${FLOAT_DECIMAL_POINT:=.} # Use C locale default as fall-back

############################################################ FUNCTIONS

# f_float [OPTIONS] number OP number [var_to_set]
#
# Perform floating operation OP between two numbers.
#
# If $var_to_set is missing or NULL, output is to standard out.
#
f_float()
{
        local __funcname=f_float
        local __f_float_np=
        local __f_float_round=
        while [ $# -gt 0 ]; do
                case "$1" in
                -n) shift 1 && __f_float_np="$1" ;;
                -n?*) __f_float_np="${1#-n}" ;;
                -r) __f_float_round=1 ;;
                -rn) __f_float_round=1; shift 1 && __f_float_np="$1" ;;
                -rn?*) __f_float_round=1; __f_float_np="${1#-rn}" ;;
                --) shift 1; break ;;
                -[0-9]*) break ;;
                -*) echo "$__funcname: Illegal option $1" >&2
                    return $FAILURE ;;
                *) break
                esac
                shift 1
        done
        local __f_float_op=unknown
        case "$2" in
        +) __f_float_op=add ;;
        /) __f_float_op=divide ;;
        *) echo "$__funcname: unsupported arithmetic operator \`$2'" >&2
           return $FAILURE
        esac
        eval f_float_$__f_float_op ${__f_float_np:+-n \"\$__f_float_np\"} \
                ${__f_float_round:+-r} -- \"\$@\"
}

# f_float_add [--] float [+] float [var_to_set]
#
# Add two floats.
#
# If $var_to_set is missing or NULL, output is to standard out.
#
f_float_add()
{
        local __funcname=f_float_add
        while [ $# -gt 0 ]; do
                case "$1" in
                --) shift 1; break ;;
                -[0-9]*) break ;;
                -*) echo "$__funcname: Illegal option $1" >&2
                    return $FAILURE ;;
                *) break
                esac
                shift 1
        done
        local __float1="${1:-0}" __float2="${2:-0}" __var_to_set="$3"
        [ "$__float2" = + ] && __float2="${3:-0}" __var_to_set="$4"

        #
        # Sanitize float inputs
        #
        __float1="${__float1%%[!-0-9$FLOAT_DECIMAL_POINT]*}"
        __float2="${__float2%%[!-0-9$FLOAT_DECIMAL_POINT]*}"

        #
        # Parse float inputs
        #
        local __fi1 __fd1=
        local __fi2 __fd2=
        case $__float1 in
        *$FLOAT_DECIMAL_POINT*)
                __fi1=${__float1%%$FLOAT_DECIMAL_POINT*}
                __fd1=${__float1#*$FLOAT_DECIMAL_POINT}
                ;;
        *)
                __fi1=$__float1
        esac
        while [ "$__fi1" != "${__fi1#0}" ]; do
                __fi1=${__fi1#0}
        done
        : ${__fi1:=0}
        case $__float2 in
        *$FLOAT_DECIMAL_POINT*)
                __fi2=${__float2%%$FLOAT_DECIMAL_POINT*}
                __fd2=${__float2#*$FLOAT_DECIMAL_POINT}
                ;;
        *)
                __fi2=$__float2
        esac
        while [ "$__fi2" != "${__fi2#0}" ]; do
                __fi2=${__fi2#0}
        done
        : ${__fi2:=0}

        #
        # Test for overflow on integer part of float inputs
        #
        if [ $__fi1 -ne 0 ] 2> /dev/null; then
                : no overflow
        elif [ $? -gt 1 ]; then
                echo "$__funcname: $__float1: out of range" >&2
                [ "$__var_to_set" ] && setvar "$__var_to_set" ""
                return $FAILURE
        fi
        if [ $__fi2 -ne 0 ] 2> /dev/null; then
                : no overflow
        elif [ $? -gt 1 ]; then
                echo "$__funcname: $__float2: out of range" >&2
                [ "$__var_to_set" ] && setvar "$__var_to_set" ""
                return $FAILURE
        fi

        #
        # Perform integer part of floating-point calculation
        #
        local __sumi=$(( $__fi1 + $__fi2 )) __overflow=
        if [ $__fi1 -gt 0 ]; then
                [ $__fi2 -gt 0 -a $__sumi -lt 0 ] && __overflow=1
        elif [ $__fi2 -lt 0 -a $__sumi -gt 0 ]; then
                __overflow=1
        fi
        if [ "$__overflow" ]; then
                echo "$__funcname: $__float1 + $__float2:" \
                     "result out of range" >&2
                [ "$__var_to_set" ] && setvar "$__var_to_set" ""
                return $FAILURE
        fi

        #
        # Perform decimal part of floating-point calculation
        #
        local __sumd=
        if [ "$__fd1" -o "$__fd2" ]; then
                # Remove leading [common] zeroes
                local __lpad=0
                : ${__fd1:=0} ${__fd2:=0}
                while [ "$__fd1" != "${__fd1#0}" -a \
                        "$__fd2" != "${__fd2#0}" ]
                do
                        __lpad=$(( $__lpad + 1 ))
                        __fd1=${__fd1#0}
                        __fd2=${__fd2#0}
                done
                : ${__fd1:=0} ${__fd2:=0}

                # Align parts to same order of magnitude
                while [ ${#__fd1} -lt ${#__fd2} ]; do __fd1=${__fd1}0; done
                while [ ${#__fd2} -lt ${#__fd1} ]; do __fd2=${__fd2}0; done

                # Remove leading zeroes
                while [ "$__fd1" != "${__fd1#0}" ]; do __fd1=${__fd1#0}; done
                while [ "$__fd2" != "${__fd2#0}" ]; do __fd2=${__fd2#0}; done
                : ${__fd1:=0} ${__fd2:=0}

                # Remove trailing zeroes
                while [ "$__fd1" != "${__fd1%0}" -a \
                        "$__fd2" != "${__fd2%0}" ]
                do
                        __fd1=${__fd1%0}
                        __fd2=${__fd2%0}
                done
                : ${__fd1:=0} ${__fd2:=0}

                # Test for overflow
                if [ $__fd1 -ne 0 ] 2> /dev/null; then
                        : no overflow
                elif [ $? -gt 1 ]; then
                        echo "$__funcname: $__float1 + $__float2:" \
                             "result out of range" >&2
                        [ "$__var_to_set" ] && setvar "$__var_to_set" ""
                        return $FAILURE
                fi
                if [ $__fd2 -ne 0 ] 2> /dev/null; then
                        : no overflow
                elif [ $? -gt 1 ]; then
                        echo "$__funcname: $__float1 + $__float2:" \
                             "result out of range" >&2
                        [ "$__var_to_set" ] && setvar "$__var_to_set" ""
                        return $FAILURE
                fi

                # Calculate expected radix count for sum
                local __len
                if [ ${#__fd1} -gt ${#__fd2} ]; then
                        __len=${#__fd1}
                else
                        __len=${#__fd2}
                fi

                # Sum decimal parts and test for overflow
                __sumd=$(( $__fd1 + $__fd2 ))
                if [ $__sumd -lt 0 ]; then
                        echo "$__funcname: $__float1 + $__float2:" \
                             "result out of range" >&2
                        [ "$__var_to_set" ] && setvar "$__var_to_set" ""
                        return $FAILURE
                fi

                # Increment integer part if new radix was generated
                if [ ${#__sumd} -gt $__len ]; then
                        __lpad=$(( $__lpad - 1 ))
                        if [ $__lpad -lt 0 ]; then
                                __sumd=${__sumd#1}
                                __sumi=$(( $__sumi + 1 ))
                        fi
                        __overflow=
                        if [ $__fi1 -gt 0 ]; then
                                [ $__fi2 -gt 0 -a $__sumi -lt 0 ] &&
                                        __overflow=1
                        elif [ $__fi2 -lt 0 -a $__sumi -gt 0 ]; then
                                __overflow=1
                        fi
                        if [ "$__overflow" ]; then
                                echo "$__funcname: $__float1 + $__float2:" \
                                     "result out of range" >&2
                                [ "$__var_to_set" ] &&
                                        setvar "$__var_to_set" ""
                                return $FAILURE
                        fi
                fi

                # Remove trailing zeroes
                while [ "$__sumd" != "${__sumd%0}" ]; do
                        __sumd=${__sumd%0}
                done
                : ${__sumd:=0}

                # Restore leading zeroes
                if [ $__sumd -gt 0 ]; then
                        while [ $__lpad -gt 0 ]; do
                                __sumd=0$__sumd
                                __lpad=$(( $__lpad - 1 ))
                        done
                fi
        fi

        #
        # Combine integer and decimal parts and return result
        #
        __sum=$__sumi${__sumd:+$FLOAT_DECIMAL_POINT}$__sumd

        #
        # Return result
        #
        if [ "$__var_to_set" ]; then
                setvar "$__var_to_set" "$__sum"
        else
                echo "$__sum"
        fi
}

# f_float_round_up float [var_to_set]
#
# Round float up by one.
#
f_float_round_up()
{
        local __float="$1" __var_to_set="$2"
        local __fi __fd __fl __ii=1 __overflow=
        case "$__float" in
        *$FLOAT_DECIMAL_POINT*)
                __fi=${__float%%$FLOAT_DECIMAL_POINT*}
                __fd=${__float#*$FLOAT_DECIMAL_POINT}
                __fl=${#__fd}
                ;;
        *)
                __fi=$__float
                __fd=
        esac
        if [ "$__fd" ]; then
                local __lpad=0
                while [ "$__fd" != "${__fd#0}" ]; do
                        __lpad=$(( $__lpad + 1 ))
                        __fl=$(( $__fl - 1 ))
                        __fd=${__fd#0}
                done
                : ${__fd:=0}
                __fd=$(( $__fd + 1 ))
                if [ $__fd -lt 0 ]; then
                        __overflow=1
                else
                        [ ${#__fd} -ne $__fl ] || __ii=
                        while [ $__lpad -gt 0 ]; do
                                __fd=0$__fd
                                __lpad=$(( $__lpad - 1 ))
                        done
                fi
        fi
        if [ "$__ii" -a ! "$__overflow" ]; then
                __fd=${__fd#1}
                if [ "$__fi" = "${__fi#-}" ]; then
                        __fi=$(( $__fi + 1 ))
                        [ $__fi -gt 0 ] || __overflow=1
                else
                        __fi=$(( $__fi - 1 ))
                        [ $__fi -lt 0 ] || __overflow=1
                fi
        fi
        if [ "$__overflow" ]; then
                echo "$__funcname: floating point conversion overflow" \
                     "(unable to round)" >&2
                return $FAILURE
        fi
        __float="$__fi${__fd:+$FLOAT_DECIMAL_POINT}$__fd"
        if [ "$__var_to_set" ]; then
                setvar "$__var_to_set" "$__float"
        else
                echo "$__float"
        fi
}

# f_float_divide [-r] [-n precision] [--] integer [/] divisor [var_to_set]
#
# Divide integer by divisor, producing a floating-point number with precision
# decimal places. If the `-r' flag is given, round up to the nearest tenth.
#
# If $var_to_set is missing or NULL, output is to standard out.
#
f_float_divide()
{
        local __funcname=f_float_divide __np=2 __n=1 __round=
        while [ $# -gt 0 ]; do
                case "$1" in
                -n) shift 1 && __np="$1" ;;
                -n?*) __np="${1#-n}" ;;
                -r) __round=1 ;;
                -rn) __round=1; shift 1 && __np="$1" ;;
                -rn?*) __round=1; __np="${1#-rn}" ;;
                --) shift 1; break ;;
                -[0-9]*) break ;;
                -*) echo "$__funcname: Illegal option $1" >&2
                    return $FAILURE ;;
                *) break
                esac
                shift 1
        done
        local __remainder="${1:-0}" __divisor="${2:-1}" __var_to_set="$3"
        [ "$__divisor" = / ] && __divisor="${3:-1}" __var_to_set="$4"

        #
        # Currently only whole integers allowed as input (trim floats)
        #
        __remainder="${__remainder%%[!-0-9]*}"
        __divisor="${__divisor%%[!-0-9]*}"
        : ${__remainder:=0} ${__divisor:=1}
        if [ $__remainder -eq 0 ] 2> /dev/null; then
                : simply testing for integer overflow
        elif [ $? -eq 2 ]; then
                echo "$__funcname: $__remainder: out of range" >&2
                [ "$__var_to_set" ] && setvar "$__var_to_set" ""
                return $FAILURE
        fi
        if [ $__divisor -eq 0 ] 2> /dev/null; then
                echo "$__funcname: $__remainder / $__divisor:" \
                     "division by 0" >&2
                [ "$__var_to_set" ] && setvar "$__var_to_set" ""
                return $FAILURE
        elif [ $? -eq 2 ]; then
                echo "$__funcname: $__divisor: out of range" >&2
                [ "$__var_to_set" ] && setvar "$__var_to_set" ""
                return $FAILURE
        fi

        #
        # Perform floating-point calculation
        #
        local __quotient=$(( $__remainder / $__divisor )) __floatnum
        if [ $__quotient -eq 0 ]; then
                if [ $__remainder -lt 0 -a $__divisor -ge 0 ] ||
                   [ $__divisor -lt 0 -a $__remainder -ge 0 ]
                then
                        __quotient="-$__quotient"
                fi
        fi
        [ $__np -gt 0 ] && __quotient=$__quotient$FLOAT_DECIMAL_POINT
        while [ $__n -le $__np ]; do
                __remainder=$(( $__remainder % $__divisor * 10 ))
                __floatnum=$(( $__remainder / $__divisor ))
                __quotient=$__quotient${__floatnum#-}
                __n=$(( $__n + 1 ))
        done

        #
        # Round up if necessary
        #
        if [ "$__round" ]; then
                __remainder=$(( $__remainder % $__divisor * 10 ))
                if [ $(( $__remainder / $__divisor )) -ge 5 ]; then
                        local __f_float_divide_float
                        f_float_round_up $__quotient __f_float_divide_float &&
                                __quotient="$__f_float_divide_float"
                fi
        fi

        #
        # Return result
        #
        if [ "$__var_to_set" ]; then
                setvar "$__var_to_set" "$__quotient"
        else
                echo "$__quotient"
        fi
}

fi # ! $_FLOAT_SUBR

common.subr (without the change to the top line):
if [ ! "$_COMMON_SUBR" ]; then _COMMON_SUBR=1
#
# Copyright (c) 2012 Ron McDowell
# Copyright (c) 2012-2016 Devin Teske
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $FreeBSD$
#
############################################################ CONFIGURATION

#
# Default file descriptors to link to stdout/stderr for passthru allowing
# redirection within a sub-shell to bypass directly to the terminal.
#
: ${TERMINAL_STDOUT_PASSTHRU:=3}
: ${TERMINAL_STDERR_PASSTHRU:=4}

############################################################ GLOBALS

#
# Program name
#
pgm="${0##*/}"

#
# Program arguments
#
ARGC="$#"
ARGV="$@"

#
# Global exit status variables
#
SUCCESS=0
FAILURE=1

#
# Operating environment details
#
export UNAME_S="$( uname -s )" # Operating System (i.e. FreeBSD)
export UNAME_P="$( uname -p )" # Processor Architecture (i.e. i386)
export UNAME_M="$( uname -m )" # Machine platform (i.e. i386)
export UNAME_R="$( uname -r )" # Release Level (i.e. X.Y-RELEASE)

#
# Default behavior is to call f_debug_init() automatically when loaded.
#
: ${DEBUG_SELF_INITIALIZE=1}

#
# Default behavior of f_debug_init() is to truncate $debugFile (set to NULL to
# disable truncating the debug file when initializing). To get child processes
# to append to the same log file, export this variarable (with a NULL value)
# and also export debugFile with the desired value.
#
: ${DEBUG_INITIALIZE_FILE=1}

#
# Define standard optstring arguments that should be supported by all programs
# using this include (unless DEBUG_SELF_INITIALIZE is set to NULL to prevent
# f_debug_init() from autamatically processing "$@" for the below arguments):
#
#       d       Sets $debug to 1
#       D:      Sets $debugFile to $OPTARG
#
GETOPTS_STDARGS="dD:"

#
# The getopts builtin will return 1 either when the end of "$@" or the first
# invalid flag is reached. This makes it impossible to determine if you've
# processed all the arguments or simply have hit an invalid flag. In the cases
# where we want to tolerate invalid flags (f_debug_init() for example), the
# following variable can be appended to your optstring argument to getopts,
# preventing it from prematurely returning 1 before the end of the arguments.
#
# NOTE: This assumes that all unknown flags are argument-less.
#
GETOPTS_ALLFLAGS="abcdefghijklmnopqrstuvwxyz"
GETOPTS_ALLFLAGS="${GETOPTS_ALLFLAGS}ABCDEFGHIJKLMNOPQRSTUVWXYZ"
GETOPTS_ALLFLAGS="${GETOPTS_ALLFLAGS}0123456789"

#
# When we get included, f_debug_init() will fire (unless $DEBUG_SELF_INITIALIZE
# is set to disable automatic initialization) and process "$@" for a few global
# options such as `-d' and/or `-D file'. However, if your program takes custom
# flags that take arguments, this automatic processing may fail unexpectedly.
#
# The solution to this problem is to pre-define (before including this file)
# the following variable (which defaults to NULL) to indicate that there are
# extra flags that should be considered when performing automatic processing of
# globally persistent flags.
#
: ${GETOPTS_EXTRA:=}

############################################################ FUNCTIONS

# f_dprintf $format [$arguments ...]
#
# Sensible debug function. Override in ~/.bsdconfigrc if desired.
# See /usr/share/examples/bsdconfig/bsdconfigrc for example.
#
# If $debug is set and non-NULL, prints DEBUG info using printf(1) syntax:
#       + To $debugFile, if set and non-NULL
#       + To standard output if $debugFile is either NULL or unset
#       + To both if $debugFile begins with a single plus-sign (`+')
#
f_dprintf()
{
        [ "$debug" ] || return $SUCCESS
        local fmt="$1"; shift
        case "$debugFile" in ""|+*)
        printf "DEBUG: $fmt${fmt:+\n}" "$@" >&${TERMINAL_STDOUT_PASSTHRU:-1}
        esac
        [ "${debugFile#+}" ] &&
                printf "DEBUG: $fmt${fmt:+\n}" "$@" >> "${debugFile#+}"
        return $SUCCESS
}

# f_debug_init
#
# Initialize debugging. Truncates $debugFile to zero bytes if set.
#
f_debug_init()
{
        #
        # Process stored command-line arguments
        #
        set -- $ARGV
        local OPTIND OPTARG flag
        f_dprintf "f_debug_init: ARGV=[%s] GETOPTS_STDARGS=[%s]" \
                  "$ARGV" "$GETOPTS_STDARGS"
        while getopts "$GETOPTS_STDARGS$GETOPTS_EXTRA$GETOPTS_ALLFLAGS" flag \
        > /dev/null; do
                case "$flag" in
                d) debug=1 ;;
                D) debugFile="$OPTARG" ;;
                esac
        done
        shift $(( $OPTIND - 1 ))
        f_dprintf "f_debug_init: debug=[%s] debugFile=[%s]" \
                  "$debug" "$debugFile"

        #
        # Automagically enable debugging if debugFile is set (and non-NULL)
        #
        [ "$debugFile" ] && { [ "${debug+set}" ] || debug=1; }

        #
        # Make debugging persistant if set
        #
        [ "$debug" ] && export debug
        [ "$debugFile" ] && export debugFile

        #
        # Truncate debug file unless requested otherwise. Note that we will
        # trim a leading plus (`+') from the value of debugFile to support
        # persistant meaning that f_dprintf() should print both to standard
        # output and $debugFile (minus the leading plus, of course).
        #
        local _debug_file="${debugFile#+}"
        if [ "$_debug_file" -a "$DEBUG_INITIALIZE_FILE" ]; then
                if ( umask 022 && :> "$_debug_file" ); then
                        f_dprintf "Successfully initialized debugFile \`%s'" \
                                  "$_debug_file"
                        f_isset debug || debug=1 # turn debugging on if not set
                else
                        unset debugFile
                        f_dprintf "Unable to initialize debugFile \`%s'" \
                                  "$_debug_file"
                fi
        fi
}

# f_err $format [$arguments ...]
#
# Print a message to stderr (fd=2).
#
f_err()
{
        printf "$@" >&2
}

# f_quietly $command [$arguments ...]
#
# Run a command quietly (quell any output to stdout or stderr)
#
f_quietly()
{
        "$@" > /dev/null 2>&1
}

# f_have $anything ...
#
# A wrapper to the `type' built-in. Returns true if argument is a valid shell
# built-in, keyword, or externally-tracked binary, otherwise false.
#
f_have()
{
        f_quietly type "$@"
}

# setvar $var_to_set [$value]
#
# Implement setvar for shells unlike FreeBSD sh(1).
#
if ! f_have setvar; then
setvar()
{
        [ $# -gt 0 ] || return $SUCCESS
        local __setvar_var_to_set="$1" __setvar_right="$2" __setvar_left=
        case $# in
        1) unset "$__setvar_var_to_set"
           return $? ;;
        2) : fall through ;;
        *) f_err "setvar: too many arguments\n"
           return $FAILURE
        esac
        case "$__setvar_var_to_set" in *[!0-9A-Za-z_]*)
                f_err "setvar: %s: bad variable name\n" "$__setvar_var_to_set"
                return 2
        esac
        while case "$__setvar_r" in *\'*) : ;; *) false ; esac
        do
                __setvar_left="$__setvar_left${__setvar_right%%\'*}'\\''"
                __setvar_right="${__setvar_right#*\'}"
        done
        __setvar_left="$__setvar_left${__setvar_right#*\'}"
        eval "$__setvar_var_to_set='$__setvar_left'"
}
fi

# f_which $anything [$var_to_set]
#
# A fast built-in replacement for syntaxes such as foo=$( which bar ). In a
# comparison of 10,000 runs of this function versus which, this function
# completed in under 3 seconds, while `which' took almost a full minute.
#
# If $var_to_set is missing or NULL, output is (like which) to standard out.
# Returns success if a match was found, failure otherwise.
#
f_which()
{
        local __name="$1" __var_to_set="$2"
        case "$__name" in */*|'') return $FAILURE; esac
        local __p __exec IFS=":" __found=
        for __p in $PATH; do
                __exec="$__p/$__name"
                [ -f "$__exec" -a -x "$__exec" ] && __found=1 break
        done
        if [ "$__found" ]; then
                if [ "$__var_to_set" ]; then
                        setvar "$__var_to_set" "$__exec"
                else
                        echo "$__exec"
                fi
                return $SUCCESS
        fi
        return $FAILURE
}

# f_getvar $var_to_get [$var_to_set]
#
# Utility function designed to go along with the already-builtin setvar.
# Allows clean variable name indirection without forking or sub-shells.
#
# Returns error status if the requested variable ($var_to_get) is not set.
#
# If $var_to_set is missing or NULL, the value of $var_to_get is printed to
# standard output for capturing in a sub-shell (which is less-recommended
# because of performance degredation; for example, when called in a loop).
#
f_getvar()
{
        local __var_to_get="$1" __var_to_set="$2"
        [ "$__var_to_set" ] || local value
        eval [ \"\${$__var_to_get+set}\" ]
        local __retval=$?
        eval ${__var_to_set:-value}=\"\${$__var_to_get}\"
        eval f_dprintf '"f_getvar: var=[%s] value=[%s] r=%u"' \
                \"\$__var_to_get\" \"\$${__var_to_set:-value}\" \$__retval
        [ "$__var_to_set" ] || { [ "$value" ] && echo "$value"; }
        return $__retval
}

# f_isset $var
#
# Check if variable $var is set. Returns success if variable is set, otherwise
# returns failure.
#
f_isset()
{
        eval [ \"\${${1%%[$IFS]*}+set}\" ]
}

# f_die [$status [$format [$arguments ...]]]
#
# Abruptly terminate due to an error optionally displaying a message in a
# dialog box using printf(1) syntax.
#
f_die()
{
        local status=$FAILURE

        # If there is at least one argument, take it as the status
        if [ $# -gt 0 ]; then
                status=$1
                shift 1 # status
        fi

        # If there are still arguments left, pass them to f_show_msg
        [ $# -gt 0 ] && f_show_msg "$@"

        # Optionally call f_clean_up() function if it exists
        f_have f_clean_up && f_clean_up

        exit $status
}

# f_interrupt
#
# Interrupt handler.
#
f_interrupt()
{
        exec 2>&1 # fix sh(1) bug where stderr gets lost within async-trap
        f_die
}

# f_show_info $format [$arguments ...]
#
# Display a message in a dialog infobox using printf(1) syntax.
#
f_show_info()
{
        local msg
        msg=$( printf "$@" )

        #
        # Use f_dialog_infobox from dialog.subr if possible, otherwise fall
        # back to dialog(1) (without options, making it obvious when using
        # un-aided system dialog).
        #
        if f_have f_dialog_info; then
                f_dialog_info "$msg"
        else
                dialog --infobox "$msg" 0 0
        fi
}

# f_show_msg $format [$arguments ...]
#
# Display a message in a dialog box using printf(1) syntax.
#
f_show_msg()
{
        local msg
        msg=$( printf "$@" )

        #
        # Use f_dialog_msgbox from dialog.subr if possible, otherwise fall
        # back to dialog(1) (without options, making it obvious when using
        # un-aided system dialog).
        #
        if f_have f_dialog_msgbox; then
                f_dialog_msgbox "$msg"
        else
                dialog --msgbox "$msg" 0 0
        fi
}

# f_show_err $format [$arguments ...]
#
# Display a message in a dialog box with ``Error'' i18n title (overridden by
# setting msg_error) using printf(1) syntax.
#
f_show_err()
{
        local msg
        msg=$( printf "$@" )

        : ${msg:=${msg_an_unknown_error_occurred:-An unknown error occurred}}

        if [ "$_DIALOG_SUBR" ]; then
                f_dialog_title "${msg_error:-Error}"
                f_dialog_msgbox "$msg"
                f_dialog_title_restore
        else
                dialog --title "${msg_error:-Error}" --msgbox "$msg" 0 0
        fi
        return $SUCCESS
}

# f_yesno $format [$arguments ...]
#
# Display a message in a dialog yes/no box using printf(1) syntax.
#
f_yesno()
{
        local msg
        msg=$( printf "$@" )

        #
        # Use f_dialog_yesno from dialog.subr if possible, otherwise fall
        # back to dialog(1) (without options, making it obvious when using
        # un-aided system dialog).
        #
        if f_have f_dialog_yesno; then
                f_dialog_yesno "$msg"
        else
                dialog --yesno "$msg" 0 0
        fi
}

# f_noyes $format [$arguments ...]
#
# Display a message in a dialog yes/no box using printf(1) syntax.
# NOTE: THis is just like the f_yesno function except "No" is default.
#
f_noyes()
{
        local msg
        msg=$( printf "$@" )

        #
        # Use f_dialog_noyes from dialog.subr if possible, otherwise fall
        # back to dialog(1) (without options, making it obvious when using
        # un-aided system dialog).
        #
        if f_have f_dialog_noyes; then
                f_dialog_noyes "$msg"
        else
                dialog --defaultno --yesno "$msg" 0 0
        fi
}

# f_show_help $file
#
# Display a language help-file. Automatically takes $LANG and $LC_ALL into
# consideration when displaying $file (suffix ".$LC_ALL" or ".$LANG" will
# automatically be added prior to loading the language help-file).
#
# If a language has been requested by setting either $LANG or $LC_ALL in the
# environment and the language-specific help-file does not exist we will fall
# back to $file without-suffix.
#
# If the language help-file does not exist, an error is displayed instead.
#
f_show_help()
{
        local file="$1"
        local lang="${LANG:-$LC_ALL}"

        [ -f "$file.$lang" ] && file="$file.$lang"

        #
        # Use f_dialog_textbox from dialog.subr if possible, otherwise fall
        # back to dialog(1) (without options, making it obvious when using
        # un-aided system dialog).
        #
        if f_have f_dialog_textbox; then
                f_dialog_textbox "$file"
        else
                dialog --msgbox "$( cat "$file" 2>&1 )" 0 0
        fi
}

# f_include $file
#
# Include a shell subroutine file.
#
# If the subroutine file exists but returns error status during loading, exit
# is called and execution is prematurely terminated with the same error status.
#
f_include()
{
        local file="$1"
        f_dprintf "f_include: file=[%s]" "$file"
        . "$file" || exit $?
}

# f_include_lang $file
#
# Include a language file. Automatically takes $LANG and $LC_ALL into
# consideration when including $file (suffix ".$LC_ALL" or ".$LANG" will
# automatically by added prior to loading the language file).
#
# No error is produced if (a) a language has been requested (by setting either
# $LANG or $LC_ALL in the environment) and (b) the language file does not
# exist -- in which case we will fall back to loading $file without-suffix.
#
# If the language file exists but returns error status during loading, exit
# is called and execution is prematurely terminated with the same error status.
#
f_include_lang()
{
        local file="$1"
        local lang="${LANG:-$LC_ALL}"

        f_dprintf "f_include_lang: file=[%s] lang=[%s]" "$file" "$lang"
        if [ -f "$file.$lang" ]; then
                . "$file.$lang" || exit $?
        else
                . "$file" || exit $?
        fi
}

# f_usage $file [$key1 $value1 ...]
#
# Display USAGE file with optional pre-processor macro definitions. The first
# argument is the template file containing the usage text to be displayed. If
# $LANG or $LC_ALL (in order of preference, respectively) is set, ".encoding"
# will automatically be appended as a suffix to the provided $file pathname.
#
# When processing $file, output begins at the first line containing that is
# (a) not a comment, (b) not empty, and (c) is not pure-whitespace. All lines
# appearing after this first-line are output, including (a) comments (b) empty
# lines, and (c) lines that are purely whitespace-only.
#
# If additional arguments appear after $file, substitutions are made while
# printing the contents of the USAGE file. The pre-processor macro syntax is in
# the style of autoconf(1), for example:
#
#       f_usage $file "FOO" "BAR"
#
# Will cause instances of "@FOO@" appearing in $file to be replaced with the
# text "BAR" before being printed to the screen.
#
# This function is a two-parter. Below is the awk(1) portion of the function,
# afterward is the sh(1) function which utilizes the below awk script.
#
f_usage_awk='
BEGIN { found = 0 }
{
        if ( !found && $0 ~ /^[[:space:]]*($|#)/ ) next
        found = 1
        print
}
'
f_usage()
{
        local file="$1"
        local lang="${LANG:-$LC_ALL}"

        f_dprintf "f_usage: file=[%s] lang=[%s]" "$file" "$lang"

        shift 1 # file

        local usage
        if [ -f "$file.$lang" ]; then
                usage=$( awk "$f_usage_awk" "$file.$lang" ) || exit $FAILURE
        else
                usage=$( awk "$f_usage_awk" "$file" ) || exit $FAILURE
        fi

        while [ $# -gt 0 ]; do
                local key="$1"
                export value="$2"
                usage=$( echo "$usage" | awk \
                        "{ gsub(/@$key@/, ENVIRON[\"value\"]); print }" )
                shift 2
        done

        f_err "%s\n" "$usage"

        exit $FAILURE
}

# f_index_file $keyword [$var_to_set]
#
# Process all INDEX files known to bsdconfig and return the path to first file
# containing a menu_selection line with a keyword portion matching $keyword.
#
# If $LANG or $LC_ALL (in order of preference, respectively) is set,
# "INDEX.encoding" files will be searched first.
#
# If no file is found, error status is returned along with the NULL string.
#
# If $var_to_set is NULL or missing, output is printed to stdout (which is less
# recommended due to performance degradation; in a loop for example).
#
# This function is a two-parter. Below is the awk(1) portion of the function,
# afterward is the sh(1) function which utilizes the below awk script.
#
f_index_file_awk='
# Variables that should be defined on the invocation line:
#       -v keyword="keyword"
BEGIN { found = 0 }
( $0 ~ "^menu_selection=\"" keyword "\\|" ) {
        print FILENAME
        found++
        exit
}
END { exit ! found }
'
f_index_file()
{
        local __keyword="$1" __var_to_set="$2"
        local __lang="${LANG:-$LC_ALL}"
        local __indexes="$BSDCFG_LIBE${BSDCFG_LIBE:+/}*/INDEX"

        f_dprintf "f_index_file: keyword=[%s] lang=[%s]" "$__keyword" "$__lang"

        if [ "$__lang" ]; then
                if [ "$__var_to_set" ]; then
                        eval "$__var_to_set"='"$( awk -v keyword="$__keyword" \
                                "$f_index_file_awk" $__indexes.$__lang
                        )"' && return $SUCCESS
                else
                        awk -v keyword="$__keyword" "$f_index_file_awk" \
                                $__indexes.$__lang && return $SUCCESS
                fi
                # No match, fall-thru to non-i18n sources
        fi
        if [ "$__var_to_set" ]; then
                eval "$__var_to_set"='"$( awk -v keyword="$__keyword" \
                        "$f_index_file_awk" $__indexes )"' && return $SUCCESS
        else
                awk -v keyword="$__keyword" "$f_index_file_awk" $__indexes &&
                        return $SUCCESS
        fi

        # No match? Fall-thru to `local' libexec sources (add-on modules)

        [ "$BSDCFG_LOCAL_LIBE" ] || return $FAILURE
        __indexes="$BSDCFG_LOCAL_LIBE/*/INDEX"
        if [ "$__lang" ]; then
                if [ "$__var_to_set" ]; then
                        eval "$__var_to_set"='"$( awk -v keyword="$__keyword" \
                                "$f_index_file_awk" $__indexes.$__lang
                        )"' && return $SUCCESS
                else
                        awk -v keyword="$__keyword" "$f_index_file_awk" \
                                $__indexes.$__lang && return $SUCCESS
                fi
                # No match, fall-thru to non-i18n sources
        fi
        if [ "$__var_to_set" ]; then
                eval "$__var_to_set"='$( awk -v keyword="$__keyword" \
                        "$f_index_file_awk" $__indexes )"'
        else
                awk -v keyword="$__keyword" "$f_index_file_awk" $__indexes
        fi
}

# f_index_menusel_keyword $indexfile $pgm [$var_to_set]
#
# Process $indexfile and return only the keyword portion of the menu_selection
# line with a command portion matching $pgm.
#
# This function is for internationalization (i18n) mapping of the on-disk
# scriptname ($pgm) into the localized language (given language-specific
# $indexfile). If $LANG or $LC_ALL (in orderder of preference, respectively) is
# set, ".encoding" will automatically be appended as a suffix to the provided
# $indexfile pathname.
#
# If, within $indexfile, multiple $menu_selection values map to $pgm, only the
# first one will be returned. If no mapping can be made, the NULL string is
# returned.
#
# If $indexfile does not exist, error status is returned with NULL.
#
# If $var_to_set is NULL or missing, output is printed to stdout (which is less
# recommended due to performance degradation; in a loop for example).
#
# This function is a two-parter. Below is the awk(1) portion of the function,
# afterward is the sh(1) function which utilizes the below awk script.
#
f_index_menusel_keyword_awk='
# Variables that should be defined on the invocation line:
#       -v pgm="program_name"
#
BEGIN {
        prefix = "menu_selection=\""
        plen = length(prefix)
        found = 0
}
{
        if (!match($0, "^" prefix ".*\\|.*\"")) next

        keyword = command = substr($0, plen + 1, RLENGTH - plen - 1)
        sub(/^.*\|/, "", command)
        sub(/\|.*$/, "", keyword)

        if ( command == pgm )
        {
                print keyword
                found++
                exit
        }
}
END { exit ! found }
'
f_index_menusel_keyword()
{
        local __indexfile="$1" __pgm="$2" __var_to_set="$3"
        local __lang="${LANG:-$LC_ALL}" __file="$__indexfile"

        [ -f "$__indexfile.$__lang" ] && __file="$__indexfile.$__lang"
        f_dprintf "f_index_menusel_keyword: index=[%s] pgm=[%s] lang=[%s]" \
                  "$__file" "$__pgm" "$__lang"

        if [ "$__var_to_set" ]; then
                setvar "$__var_to_set" "$( awk \
                    -v pgm="$__pgm" "$f_index_menusel_keyword_awk" "$__file"
                )"
        else
                awk -v pgm="$__pgm" "$f_index_menusel_keyword_awk" "$__file"
        fi
}

# f_index_menusel_command $indexfile $keyword [$var_to_set]
#
# Process $indexfile and return only the command portion of the menu_selection
# line with a keyword portion matching $keyword.
#
# This function is for mapping [possibly international] keywords into the
# command to be executed. If $LANG or $LC_ALL (order of preference) is set,
# ".encoding" will automatically be appended as a suffix to the provided
# $indexfile pathname.
#
# If, within $indexfile, multiple $menu_selection values map to $keyword, only
# the first one will be returned. If no mapping can be made, the NULL string is
# returned.
#
# If $indexfile doesn't exist, error status is returned with NULL.
#
# If $var_to_set is NULL or missing, output is printed to stdout (which is less
# recommended due to performance degradation; in a loop for example).
#
# This function is a two-parter. Below is the awk(1) portion of the function,
# afterward is the sh(1) function which utilizes the below awk script.
#
f_index_menusel_command_awk='
# Variables that should be defined on the invocation line:
#       -v key="keyword"
#
BEGIN {
        prefix = "menu_selection=\""
        plen = length(prefix)
        found = 0
}
{
        if (!match($0, "^" prefix ".*\\|.*\"")) next

        keyword = command = substr($0, plen + 1, RLENGTH - plen - 1)
        sub(/^.*\|/, "", command)
        sub(/\|.*$/, "", keyword)

        if ( keyword == key )
        {
                print command
                found++
                exit
        }
}
END { exit ! found }
'
f_index_menusel_command()
{
        local __indexfile="$1" __keyword="$2" __var_to_set="$3" __command
        local __lang="${LANG:-$LC_ALL}" __file="$__indexfile"

        [ -f "$__indexfile.$__lang" ] && __file="$__indexfile.$__lang"
        f_dprintf "f_index_menusel_command: index=[%s] key=[%s] lang=[%s]" \
                  "$__file" "$__keyword" "$__lang"

        [ -f "$__file" ] || return $FAILURE
        __command=$( awk -v key="$__keyword" \
                "$f_index_menusel_command_awk" "$__file" ) || return $FAILURE

        #
        # If the command pathname is not fully qualified fix-up/force to be
        # relative to the $indexfile directory.
        #
        case "$__command" in
        /*) : already fully qualified ;;
        *)
                local __indexdir="${__indexfile%/*}"
                [ "$__indexdir" != "$__indexfile" ] || __indexdir="."
                __command="$__indexdir/$__command"
        esac

        if [ "$__var_to_set" ]; then
                setvar "$__var_to_set" "$__command"
        else
                echo "$__command"
        fi
}

# f_running_as_init
#
# Returns true if running as init(1).
#
f_running_as_init()
{
        #
        # When a custom init(8) performs an exec(3) to invoke a shell script,
        # PID 1 becomes sh(1) and $PPID is set to 1 in the executed script.
        #
        [ ${PPID:-0} -eq 1 ] # Return status
}

# f_mounted $local_directory
# f_mounted -b $device
#
# Return success if a filesystem is mounted on a particular directory. If `-b'
# is present, instead check that the block device (or a partition thereof) is
# mounted.
#
f_mounted()
{
        local OPTIND OPTARG flag use_device=
        while getopts b flag; do
                case "$flag" in
                b) use_device=1 ;;
                esac
        done
        shift $(( $OPTIND - 1 ))
        if [ "$use_device" ]; then
                local device="$1"
                mount | grep -Eq \
                        "^$device([[:space:]]|p[0-9]|s[0-9]|\.nop|\.eli)"
        else
                [ -d "$dir" ] || return $FAILURE
                mount | grep -Eq " on $dir \([^)]+\)$"
        fi
        # Return status is that of last grep(1)
}

# f_eval_catch [-de] [-k $var_to_set] $funcname $utility \
#              $format [$arguments ...]
#
# Silently evaluate a command in a sub-shell and test for error. If debugging
# is enabled a copy of the command and its output is sent to debug (either
# stdout or file depending on environment). If an error occurs, output of the
# command is displayed in a dialog(1) msgbox using the [above] f_show_err()
# function (unless optional `-d' flag is given, then no dialog).
#
# The $funcname argument is sent to debugging while the $utility argument is
# used in the title of the dialog box. The command that is executed as well as
# sent to debugging with $funcname is the product of the printf(1) syntax
# produced by $format with optional $arguments.
#
# The following options are supported:
#
#       -d      Do not use dialog(1).
#       -e      Produce error text from failed command on stderr.
#       -k var  Save output from the command in var.
#
# Example 1:
#
#       debug=1
#       f_eval_catch myfunc echo 'echo "%s"' "Hello, World!"
#
#       Produces the following debug output:
#
#               DEBUG: myfunc: echo "Hello, World!"
#               DEBUG: myfunc: retval=0 <output below>
#               Hello, World!
#
# Example 2:
#
#       debug=1
#       f_eval_catch -k contents myfunc cat 'cat "%s"' /some/file
#       # dialog(1) Error ``cat: /some/file: No such file or directory''
#       # contents=[cat: /some/file: No such file or directory]
#
#       Produces the following debug output:
#
#               DEBUG: myfunc: cat "/some/file"
#               DEBUG: myfunc: retval=1 <output below>
#               cat: /some/file: No such file or directory
#
# Example 3:
#
#       debug=1
#       echo 123 | f_eval_catch myfunc rev rev
#
#       Produces the following debug output:
#
#               DEBUG: myfunc: rev
#               DEBUG: myfunc: retval=0 <output below>
#               321
#
# Example 4:
#
#       debug=1
#       f_eval_catch myfunc true true
#
#       Produces the following debug output:
#
#               DEBUG: myfunc: true
#               DEBUG: myfunc: retval=0 <no output>
#
# Example 5:
#
#       f_eval_catch -de myfunc ls 'ls "%s"' /some/dir
#       # Output on stderr ``ls: /some/dir: No such file or directory''
#
# Example 6:
#
#       f_eval_catch -dek contents myfunc ls 'ls "%s"' /etc
#       # Output from `ls' sent to stderr and also saved in $contents
#
f_eval_catch()
{
        local __no_dialog= __show_err= __var_to_set=

        #
        # Process local function arguments
        #
        local OPTIND OPTARG __flag
        while getopts "dek:" __flag > /dev/null; do
                case "$__flag" in
                d) __no_dialog=1 ;;
                e) __show_err=1 ;;
                k) __var_to_set="$OPTARG" ;;
                esac
        done
        shift $(( $OPTIND - 1 ))

        local __funcname="$1" __utility="$2"; shift 2
        local __cmd __output __retval

        __cmd=$( printf -- "$@" )
        f_dprintf "%s: %s" "$__funcname" "$__cmd" # Log command *before* eval
        __output=$( exec 2>&1; eval "$__cmd" )
        __retval=$?
        if [ "$__output" ]; then
                [ "$__show_err" ] && echo "$__output" >&2
                f_dprintf "%s: retval=%i <output below>\n%s" "$__funcname" \
                          $__retval "$__output"
        else
                f_dprintf "%s: retval=%i <no output>" "$__funcname" $__retval
        fi

        ! [ "$__no_dialog" -o "$nonInteractive" -o $__retval -eq $SUCCESS ] &&
                msg_error="${msg_error:-Error}${__utility:+: $__utility}" \
                        f_show_err "%s" "$__output"
                # NB: f_show_err will handle NULL output appropriately

        [ "$__var_to_set" ] && setvar "$__var_to_set" "$__output"

        return $__retval
}

# f_count $var_to_set arguments ...
#
# Sets $var_to_set to the number of arguments minus one (the effective number
# of arguments following $var_to_set).
#
# Example:
#       f_count count dog house # count=[2]
#
f_count()
{
        setvar "$1" $(( $# - 1 ))
}

# f_count_ifs $var_to_set string ...
#
# Sets $var_to_set to the number of words (split by the internal field
# separator, IFS) following $var_to_set.
#
# Example 1:
#
#       string="word1   word2   word3"
#       f_count_ifs count "$string" # count=[3]
#       f_count_ifs count $string # count=[3]
#
# Example 2:
#
#       IFS=. f_count_ifs count www.freebsd.org # count=[3]
#
# NB: Make sure to use double-quotes if you are using a custom value for IFS
# and you don't want the current value to effect the result. See example 3.
#
# Example 3:
#
#       string="a-b c-d"
#       IFS=- f_count_ifs count "$string" # count=[3]
#       IFS=- f_count_ifs count $string # count=[4]
#
f_count_ifs()
{
        local __var_to_set="$1"
        shift 1
        set -- $*
        setvar "$__var_to_set" $#
}

############################################################ MAIN

#
# Trap signals so we can recover gracefully
#
trap 'f_interrupt' INT
trap 'f_die' TERM PIPE XCPU XFSZ FPE TRAP ABRT SEGV
trap '' ALRM PROF USR1 USR2 HUP VTALRM

#
# Clone terminal stdout/stderr so we can redirect to it from within sub-shells
#
eval exec $TERMINAL_STDOUT_PASSTHRU\>\&1
eval exec $TERMINAL_STDERR_PASSTHRU\>\&2

#
# Self-initialize unless requested otherwise
#
f_dprintf "%s: DEBUG_SELF_INITIALIZE=[%s]" \
          dialog.subr "$DEBUG_SELF_INITIALIZE"
case "$DEBUG_SELF_INITIALIZE" in
""|0|[Nn][Oo]|[Oo][Ff][Ff]|[Ff][Aa][Ll][Ss][Ee]) : do nothing ;;
*) f_debug_init
esac

#
# Log our operating environment for debugging purposes
#
f_dprintf "UNAME_S=[%s] UNAME_P=[%s] UNAME_R=[%s]" \
          "$UNAME_S" "$UNAME_P" "$UNAME_R"

f_dprintf "%s: Successfully loaded." common.subr

fi # ! $_COMMON_SUBR

 

Leave a Reply

Your email address will not be published. Required fields are marked *